
//TIMER click on socket 1

#include "timer_hw.h"

//#define CountFromZero

// TFT module connections
unsigned int TFT_DataPort at GPIOE_ODR;
sbit TFT_RST at GPIOE_ODR.B8;
sbit TFT_RS at GPIOE_ODR.B12;
sbit TFT_CS at GPIOE_ODR.B15;
sbit TFT_RD at GPIOE_ODR.B10;
sbit TFT_WR at GPIOE_ODR.B11;
sbit TFT_BLED at GPIOE_ODR.B9;
// End TFT module connections

sbit TIMER_EVT at GPIOD_ODR.B1;
sbit TIMER_ALM at GPIOC_IDR.B1;

char text[24];
unsigned long ETC;    //elapsed time counter
unsigned int EC;

void Display_Init(){
  TFT_Init_ILI9341_8bit(320, 240);
  TFT_BLED = 1;
  TFT_Set_Pen(CL_AQUA, 1);
  TFT_Fill_Screen(CL_AQUA);
  TFT_Set_Font(TFT_defaultFont, CL_BLACK, FO_HORIZONTAL);
  TFT_Set_Pen(CL_AQUA, 1);

  TFT_Set_Brush(1, CL_AQUA, 0, LEFT_TO_RIGHT, CL_AQUA, CL_AQUA);

  TFT_Write_Text("Event count: ",10,10);
  TFT_Write_Text("Time count: ",10,50);
}

void MCU_Init() {
  GPIO_Digital_Output(&GPIOD_BASE, _GPIO_PINMASK_1);
  GPIO_Digital_Input(&GPIOC_BASE, _GPIO_PINMASK_1);
  TIMER_EVT = 1;
  I2C1_Init_Advanced(400000, &_GPIO_MODULE_I2C1_PB67);
  delay_ms(200);
}

void main() {
  MCU_Init();
  timer_hal_init(DS1682_I2C_Adr);
  Display_Init();
  #ifdef CountFromZero
  timer_set_ec_value(0);
  timer_set_etc_value(0);
  TIMER_EVT = 0;
  delay_ms(100);
  TIMER_EVT = 1;
  delay_ms(100);
  #endif
  while(1) {
    delay_ms(2000);
    TFT_Rectangle(100,10,200,40);
    TFT_Rectangle(80,50,200,80);
    //Event counter
    EC = timer_Get_ec_Value();
    WordToStr(EC,text);
    TFT_Write_Text(text,100,10);
    //Time counter - in quarter seconds
    ETC = timer_get_etc_value();
    LongWordToStr(ETC,text);
    TFT_Write_Text(text,100,50);
  }

}